ci: do not error when nothing with nitunit_some
[nit.git] / contrib / neo_doxygen / sh-lib / errors.sh
1 #! /bin/bash
2
3 # This file is part of NIT ( http://www.nitlanguage.org ).
4 #
5 # Licensed under the Apache License, Version 2.0 (the "License");
6 # you may not use this file except in compliance with the License.
7 # You may obtain a copy of the License at
8 #
9 # http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16
17 # Error handling.
18
19 # The program’s name.
20 prog_name=$0
21
22 # Run the specified command and exit in case of error.
23 function try {
24 "$@"
25 local status=$?
26 if [ $status -ne 0 ]; then
27 >&2 echo "${prog_name}: Error: \`$1\` failed with exit status ${status}."
28 trace
29 exit "$status"
30 fi
31 return 0
32 }
33
34 # Print the stack trace.
35 function trace {
36 local frame=0
37 >&2 caller $frame
38 local has_next=$?
39 while [ $has_next = 0 ]; do
40 ((frame++));
41 >&2 caller $frame
42 has_next=$?
43 done
44 >&2 echo "---"
45 return 0
46 }